// if possible try to position stations so they
// are centered in the area covered by a single
// radar pixel.
//
//      rx = 0-7 (radar pixel X range)
//      ry = 0-15 (radar pixel Y range)
//
//  HORIZONTAL STATIONS
//      x = rx*64 + 20
//      y = ry*64 + 8
//
//  VERTICAL STATIONS
//      x = rx*64 + 20
//      y = ry*64 + 12

const unsigned char delta_1[] =
{
  256/2, 512/4, // ship starting X, Y location
  8,            // station count
  0xaa,         // VS HS VS HS   VS HS VS HS
   20/2,   8/4, // station 1 X, Y location
   84/2,  72/4, // station 2 X, Y location
  148/2, 136/4, // station 3 X, Y location
  212/2, 200/4, // station 4 X, Y location
  276/2, 264/4, // station 5 X, Y location
  340/2, 328/4, // station 6 X, Y location
  404/2, 392/4, // station 7 X, Y location
  468/2, 460/4  // station 8 X, Y location
  
//    256, 512,        // ship starting X, Y location
//    8,               // station count
//    HS + 20, 8,      // station 1 X, Y location
//    VS + 84, 72,     // station 2 X, Y location
//    HS + 148, 136,   // station 3 X, Y location
//    VS + 212, 200,   // station 4 X, Y location
//    HS + 276, 264,   // station 5 X, Y location
//    VS + 340, 328,   // station 6 X, Y location
//    HS + 404, 392,   // station 7 X, Y location
//    VS + 468, 460    // station 8 X, Y location
};

const unsigned char delta_2[] =
{
  256/2, 768/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  480/2,  60/4, // station 1 X, Y location
  420/2, 120/4, // station 2 X, Y location
  360/2, 180/4, // station 3 X, Y location
  300/2, 240/4, // station 4 X, Y location
  240/2, 300/4, // station 5 X, Y location
  180/2, 360/4, // station 6 X, Y location
  120/2, 420/4, // station 7 X, Y location
   60/2, 480/4  // station 8 X, Y location
  
//    256, 768,   // ship starting X, Y location
//    8,          // station count
//    VS + 480,  60,   // station 1 X, Y location
//    HS +420, 120,   // station 2 X, Y location
//    VS + 360, 180,   // station 3 X, Y location
//    HS +300, 240,   // station 4 X, Y location
//    VS + 240, 300,   // station 5 X, Y location
//    HS +180, 360,   // station 6 X, Y location
//    VS + 120, 420,   // station 7 X, Y location
//    HS + 60, 480    // station 8 X, Y location
};

const unsigned char delta_3[] =
{
  256/2, 256/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
   60/2, 120/4, // station 1 X, Y location
  120/2,  60/4, // station 2 X, Y location
  480/2, 120/4, // station 3 X, Y location
  420/2,  60/4, // station 4 X, Y location
   60/2, 840/4, // station 5 X, Y location
  120/2, 900/4, // station 6 X, Y location
  480/2, 840/4, // station 7 X, Y location
  420/2, 900/4  // station 8 X, Y location
  
//    256, 256,   // ship starting X, Y location
//    8,          // station count
//    VS + 60, 120,   // station 1 X, Y location
//    HS +120,  60,   // station 2 X, Y location
//    VS +480, 120,   // station 3 X, Y location
//    HS +420,  60,   // station 4 X, Y location
//    VS + 60, 840,   // station 5 X, Y location
//    HS +120, 900,   // station 6 X, Y location
//    VS +480, 840,   // station 7 X, Y location
//    HS +420, 900    // station 8 X, Y location
};

const unsigned char delta_4[] =
{
  256/2, 768/4, // ship starting X, Y location
  8,            // station count
  0x00,         // all HS
   60/2, 512/4, // station 1 X, Y location
  120/2, 512/4, // station 2 X, Y location
  180/2, 512/4, // station 3 X, Y location
  240/2, 512/4, // station 4 X, Y location
  300/2, 512/4, // station 5 X, Y location
  360/2, 512/4, // station 6 X, Y location
  420/2, 512/4, // station 7 X, Y location
  480/2, 512/4  // station 8 X, Y location
  
//    256, 768,   // ship starting X, Y location
//    8,          // station count
//    HS +  60, 512,   // station 1 X, Y location
//    HS + 120, 512,   // station 2 X, Y location
//    HS + 180, 512,   // station 3 X, Y location
//    HS + 240, 512,   // station 4 X, Y location
//    HS + 300, 512,   // station 5 X, Y location
//    HS + 360, 512,   // station 6 X, Y location
//    HS + 420, 512,   // station 7 X, Y location
//    HS + 480, 512    // station 8 X, Y location
};

const unsigned char delta_5[] =
{
  0/2, 0/4, // ship starting X, Y location
  8,            // station count
  0xaa,         // VS HS VS HS   VS HS VS HS
  20/2,   8/4, // station 1 X, Y location
  84/2,  72/4, // station 2 X, Y location
  148/2, 136/4, // station 3 X, Y location
  212/2, 200/4, // station 4 X, Y location
  276/2, 264/4, // station 5 X, Y location
  340/2, 328/4, // station 6 X, Y location
  404/2, 392/4, // station 7 X, Y location
  468/2, 460/4  // station 8 X, Y location
  
  //    256, 512,        // ship starting X, Y location
  //    8,               // station count
  //    HS + 20, 8,      // station 1 X, Y location
  //    VS + 84, 72,     // station 2 X, Y location
  //    HS + 148, 136,   // station 3 X, Y location
  //    VS + 212, 200,   // station 4 X, Y location
  //    HS + 276, 264,   // station 5 X, Y location
  //    VS + 340, 328,   // station 6 X, Y location
  //    HS + 404, 392,   // station 7 X, Y location
  //    VS + 468, 460    // station 8 X, Y location
};

const unsigned char delta_6[] =
{
  0/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  480/2,  60/4, // station 1 X, Y location
  420/2, 120/4, // station 2 X, Y location
  360/2, 180/4, // station 3 X, Y location
  300/2, 240/4, // station 4 X, Y location
  240/2, 300/4, // station 5 X, Y location
  180/2, 360/4, // station 6 X, Y location
  120/2, 420/4, // station 7 X, Y location
  60/2, 480/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 480,  60,   // station 1 X, Y location
  //    HS +420, 120,   // station 2 X, Y location
  //    VS + 360, 180,   // station 3 X, Y location
  //    HS +300, 240,   // station 4 X, Y location
  //    VS + 240, 300,   // station 5 X, Y location
  //    HS +180, 360,   // station 6 X, Y location
  //    VS + 120, 420,   // station 7 X, Y location
  //    HS + 60, 480    // station 8 X, Y location
};

const unsigned char delta_7[] =
{
  0/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  60/2, 120/4, // station 1 X, Y location
  120/2,  60/4, // station 2 X, Y location
  480/2, 120/4, // station 3 X, Y location
  420/2,  60/4, // station 4 X, Y location
  60/2, 840/4, // station 5 X, Y location
  120/2, 900/4, // station 6 X, Y location
  480/2, 840/4, // station 7 X, Y location
  420/2, 900/4  // station 8 X, Y location
  
  //    256, 256,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 60, 120,   // station 1 X, Y location
  //    HS +120,  60,   // station 2 X, Y location
  //    VS +480, 120,   // station 3 X, Y location
  //    HS +420,  60,   // station 4 X, Y location
  //    VS + 60, 840,   // station 5 X, Y location
  //    HS +120, 900,   // station 6 X, Y location
  //    VS +480, 840,   // station 7 X, Y location
  //    HS +420, 900    // station 8 X, Y location
};

const unsigned char delta_8[] =
{
  0/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x00,         // all HS
  60/2, 512/4, // station 1 X, Y location
  120/2, 512/4, // station 2 X, Y location
  180/2, 512/4, // station 3 X, Y location
  240/2, 512/4, // station 4 X, Y location
  300/2, 512/4, // station 5 X, Y location
  360/2, 512/4, // station 6 X, Y location
  420/2, 512/4, // station 7 X, Y location
  480/2, 512/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    HS +  60, 512,   // station 1 X, Y location
  //    HS + 120, 512,   // station 2 X, Y location
  //    HS + 180, 512,   // station 3 X, Y location
  //    HS + 240, 512,   // station 4 X, Y location
  //    HS + 300, 512,   // station 5 X, Y location
  //    HS + 360, 512,   // station 6 X, Y location
  //    HS + 420, 512,   // station 7 X, Y location
  //    HS + 480, 512    // station 8 X, Y location
};

const unsigned char delta_9[] =
{
  0/2, 512/4, // ship starting X, Y location
  8,            // station count
  0xaa,         // VS HS VS HS   VS HS VS HS
  20/2,   8/4, // station 1 X, Y location
  84/2,  72/4, // station 2 X, Y location
  148/2, 136/4, // station 3 X, Y location
  212/2, 200/4, // station 4 X, Y location
  276/2, 264/4, // station 5 X, Y location
  340/2, 328/4, // station 6 X, Y location
  404/2, 392/4, // station 7 X, Y location
  468/2, 460/4  // station 8 X, Y location
  
  //    256, 512,        // ship starting X, Y location
  //    8,               // station count
  //    HS + 20, 8,      // station 1 X, Y location
  //    VS + 84, 72,     // station 2 X, Y location
  //    HS + 148, 136,   // station 3 X, Y location
  //    VS + 212, 200,   // station 4 X, Y location
  //    HS + 276, 264,   // station 5 X, Y location
  //    VS + 340, 328,   // station 6 X, Y location
  //    HS + 404, 392,   // station 7 X, Y location
  //    VS + 468, 460    // station 8 X, Y location
};

const unsigned char delta_10[] =
{
  0/2, 768/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  480/2,  60/4, // station 1 X, Y location
  420/2, 120/4, // station 2 X, Y location
  360/2, 180/4, // station 3 X, Y location
  300/2, 240/4, // station 4 X, Y location
  240/2, 300/4, // station 5 X, Y location
  180/2, 360/4, // station 6 X, Y location
  120/2, 420/4, // station 7 X, Y location
  60/2, 480/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 480,  60,   // station 1 X, Y location
  //    HS +420, 120,   // station 2 X, Y location
  //    VS + 360, 180,   // station 3 X, Y location
  //    HS +300, 240,   // station 4 X, Y location
  //    VS + 240, 300,   // station 5 X, Y location
  //    HS +180, 360,   // station 6 X, Y location
  //    VS + 120, 420,   // station 7 X, Y location
  //    HS + 60, 480    // station 8 X, Y location
};

const unsigned char delta_11[] =
{
  0/2, 256/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  60/2, 120/4, // station 1 X, Y location
  120/2,  60/4, // station 2 X, Y location
  480/2, 120/4, // station 3 X, Y location
  420/2,  60/4, // station 4 X, Y location
  60/2, 840/4, // station 5 X, Y location
  120/2, 900/4, // station 6 X, Y location
  480/2, 840/4, // station 7 X, Y location
  420/2, 900/4  // station 8 X, Y location
  
  //    256, 256,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 60, 120,   // station 1 X, Y location
  //    HS +120,  60,   // station 2 X, Y location
  //    VS +480, 120,   // station 3 X, Y location
  //    HS +420,  60,   // station 4 X, Y location
  //    VS + 60, 840,   // station 5 X, Y location
  //    HS +120, 900,   // station 6 X, Y location
  //    VS +480, 840,   // station 7 X, Y location
  //    HS +420, 900    // station 8 X, Y location
};

const unsigned char delta_12[] =
{
  0/2, 768/4, // ship starting X, Y location
  8,            // station count
  0x00,         // all HS
  60/2, 512/4, // station 1 X, Y location
  120/2, 512/4, // station 2 X, Y location
  180/2, 512/4, // station 3 X, Y location
  240/2, 512/4, // station 4 X, Y location
  300/2, 512/4, // station 5 X, Y location
  360/2, 512/4, // station 6 X, Y location
  420/2, 512/4, // station 7 X, Y location
  480/2, 512/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    HS +  60, 512,   // station 1 X, Y location
  //    HS + 120, 512,   // station 2 X, Y location
  //    HS + 180, 512,   // station 3 X, Y location
  //    HS + 240, 512,   // station 4 X, Y location
  //    HS + 300, 512,   // station 5 X, Y location
  //    HS + 360, 512,   // station 6 X, Y location
  //    HS + 420, 512,   // station 7 X, Y location
  //    HS + 480, 512    // station 8 X, Y location
};

const unsigned char delta_13[] =
{
  256/2, 0/4, // ship starting X, Y location
  8,            // station count
  0xaa,         // VS HS VS HS   VS HS VS HS
  20/2,   8/4, // station 1 X, Y location
  84/2,  72/4, // station 2 X, Y location
  148/2, 136/4, // station 3 X, Y location
  212/2, 200/4, // station 4 X, Y location
  276/2, 264/4, // station 5 X, Y location
  340/2, 328/4, // station 6 X, Y location
  404/2, 392/4, // station 7 X, Y location
  468/2, 460/4  // station 8 X, Y location
  
  //    256, 512,        // ship starting X, Y location
  //    8,               // station count
  //    HS + 20, 8,      // station 1 X, Y location
  //    VS + 84, 72,     // station 2 X, Y location
  //    HS + 148, 136,   // station 3 X, Y location
  //    VS + 212, 200,   // station 4 X, Y location
  //    HS + 276, 264,   // station 5 X, Y location
  //    VS + 340, 328,   // station 6 X, Y location
  //    HS + 404, 392,   // station 7 X, Y location
  //    VS + 468, 460    // station 8 X, Y location
};

const unsigned char delta_14[] =
{
  256/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  480/2,  60/4, // station 1 X, Y location
  420/2, 120/4, // station 2 X, Y location
  360/2, 180/4, // station 3 X, Y location
  300/2, 240/4, // station 4 X, Y location
  240/2, 300/4, // station 5 X, Y location
  180/2, 360/4, // station 6 X, Y location
  120/2, 420/4, // station 7 X, Y location
  60/2, 480/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 480,  60,   // station 1 X, Y location
  //    HS +420, 120,   // station 2 X, Y location
  //    VS + 360, 180,   // station 3 X, Y location
  //    HS +300, 240,   // station 4 X, Y location
  //    VS + 240, 300,   // station 5 X, Y location
  //    HS +180, 360,   // station 6 X, Y location
  //    VS + 120, 420,   // station 7 X, Y location
  //    HS + 60, 480    // station 8 X, Y location
};

const unsigned char delta_15[] =
{
  256/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x55,         // HS VS HS VS   HS VS HS VS
  60/2, 120/4, // station 1 X, Y location
  120/2,  60/4, // station 2 X, Y location
  480/2, 120/4, // station 3 X, Y location
  420/2,  60/4, // station 4 X, Y location
  60/2, 840/4, // station 5 X, Y location
  120/2, 900/4, // station 6 X, Y location
  480/2, 840/4, // station 7 X, Y location
  420/2, 900/4  // station 8 X, Y location
  
  //    256, 256,   // ship starting X, Y location
  //    8,          // station count
  //    VS + 60, 120,   // station 1 X, Y location
  //    HS +120,  60,   // station 2 X, Y location
  //    VS +480, 120,   // station 3 X, Y location
  //    HS +420,  60,   // station 4 X, Y location
  //    VS + 60, 840,   // station 5 X, Y location
  //    HS +120, 900,   // station 6 X, Y location
  //    VS +480, 840,   // station 7 X, Y location
  //    HS +420, 900    // station 8 X, Y location
};

const unsigned char delta_16[] =
{
  256/2, 0/4, // ship starting X, Y location
  8,            // station count
  0x00,         // all HS
  60/2, 512/4, // station 1 X, Y location
  120/2, 512/4, // station 2 X, Y location
  180/2, 512/4, // station 3 X, Y location
  240/2, 512/4, // station 4 X, Y location
  300/2, 512/4, // station 5 X, Y location
  360/2, 512/4, // station 6 X, Y location
  420/2, 512/4, // station 7 X, Y location
  480/2, 512/4  // station 8 X, Y location
  
  //    256, 768,   // ship starting X, Y location
  //    8,          // station count
  //    HS +  60, 512,   // station 1 X, Y location
  //    HS + 120, 512,   // station 2 X, Y location
  //    HS + 180, 512,   // station 3 X, Y location
  //    HS + 240, 512,   // station 4 X, Y location
  //    HS + 300, 512,   // station 5 X, Y location
  //    HS + 360, 512,   // station 6 X, Y location
  //    HS + 420, 512,   // station 7 X, Y location
  //    HS + 480, 512    // station 8 X, Y location
};


#ifdef COMPACT_LEVELS
// this idea did not work, compile time errors

const unsigned short int delta_levels[] =
{
  (unsigned short int) delta_1,
  (unsigned short int) delta_2,
  (unsigned short int) delta_3,
  (unsigned short int) delta_4,
  (unsigned short int) delta_5,
  (unsigned short int) delta_6,
  (unsigned short int) delta_7,
  (unsigned short int) delta_8,
  (unsigned short int) delta_9,
  (unsigned short int) delta_10,
  (unsigned short int) delta_11,
  (unsigned short int) delta_12,
  (unsigned short int) delta_13,
  (unsigned short int) delta_14,
  (unsigned short int) delta_15,
  (unsigned short int) delta_16
};

#else

const unsigned char * const delta_levels[] =
{
  delta_1,
  delta_2,
  delta_3,
  delta_4,
  //
  // NOTE when putting final levels in need to
  // also fix sector_counts[] and sector_repeat[] in main.c
  //
  (unsigned char *) 0x03020100, // fingerprint for level design tool
  (unsigned char *) 0x07060504, // scans for 0-2f then backs up 16 bytes
  (unsigned char *) 0x0b0a0908, // for pointer to delta_1, 12 bytes for
  (unsigned char *) 0x0f0e0d0c, // pointer to delta_2, etc.
  (unsigned char *) 0x13121110,
  (unsigned char *) 0x17161514,
  (unsigned char *) 0x1b1a1918,
  (unsigned char *) 0x1f1e1d1c,
  (unsigned char *) 0x23222120,
  (unsigned char *) 0x27262524,
  (unsigned char *) 0x2b2a2928,
  (unsigned char *) 0x2f2e2d2c,
//  delta_5,
//  delta_6,
//  delta_7,
//  delta_8,
//  delta_9,
//  delta_10,
//  delta_11,
//  delta_12,
//  delta_13,
//  delta_14,
//  delta_15,
//  delta_16
};

#endif
