// if possible try to position stations so they
// are centered in the area covered by a single
// radar pixel.
//
//      rx = 0-7 (radar pixel X range)
//      ry = 0-15 (radar pixel Y range)
//
//  HORIZONTAL STATIONS
//      x = rx*32 + 11
//      y = ry*16 + 2
//
//  VERTICAL STATIONS
//      x = rx*32 + 10
//      y = ry*16 + 3


//A - Albert
//C - Chris (cd-w)
//D - Darrell
//D - Don (Tarzilla)
//F - Fred (batari)
//M - Mike (iesposta)
//N - Nathan
//T - Thomas

const unsigned char albert[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xb5,         // VS HS VS VS   HS VS HS VS
  160/2, 389/4, // station 1 X, Y location
  162/2, 512/4, // station 2 X, Y location
  160/2, 645/4, // station 3 X, Y location
  226/2, 256/4, // station 4 X, Y location
  224/2, 517/4, // station 5 X, Y location
  288/2, 389/4, // station 6 X, Y location
  290/2, 512/4, // station 7 X, Y location
  288/2, 645/4  // station 8 X, Y location
};

const unsigned char chris[] =
{
//  01234567
//  ........ 0
//  ........ 1
//  ........ 2
//  ........ 3
//  ...**... 4
//  ........ 5
//  ..*..... 6
//  ..*..... 7
//  ..*..... 8
//  ..*..... 9
//  ........10
//  ...**...11
//  ........12
//  ........13
//  ........14
//  ........15
  
  253/2, 934/4,     // ship starting X, Y location
  8,                // station count
  0xd7,             // VS VS HS VS  HS VS VS VS
  3*32+10,  4*16+3, // station 1 X, Y location
  4*32+10,  4*16+3, // station 2 X, Y location
  2*32+10,  6*16+3, // station 3 X, Y location
  2*32+11,  7*16+2, // station 4 X, Y location
  2*32+10,  8*16+3, // station 5 X, Y location
  2*32+11,  9*16+2, // station 6 X, Y location
  3*32+10, 11*16+3, // station 7 X, Y location
  4*32+10, 11*16+3  // station 8 X, Y location
};



const unsigned char darrell[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xcf,         // VS VS HS HS   VS VS VS VS
  160/2, 260/4, // station 1 X, Y location
  160/2, 388/4, // station 2 X, Y location
  160/2, 516/4, // station 3 X, Y location
  160/2, 644/4, // station 4 X, Y location
  226/2, 256/4, // station 5 X, Y location
  226/2, 640/4, // station 6 X, Y location
  286/2, 388/4, // station 7 X, Y location
  286/2, 516/4  // station 8 X, Y location
};

const unsigned char don[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0x7a,         // HS VS VS VS  VS HS VS HS
  162/2, 256/4, // station 1 X, Y location
  160/2, 388/4, // station 2 X, Y location
  162/2, 512/4, // station 3 X, Y location
  160/2, 644/4, // station 4 X, Y location
  224/2, 260/4, // station 5 X, Y location
  224/2, 644/4, // station 6 X, Y location
  288/2, 388/4, // station 7 X, Y location
  290/2, 512/4  // station 8 X, Y location
};

const unsigned char fred[] =
{
  
  //  01234567
  //  ........ 0
  //  ........ 1
  //  ........ 2
  //  ........ 3
  //  ........ 4
  //  ...***.. 5
  //  ...*.... 6
  //  ...**... 7
  //  ...*.... 8
  //  ...*.... 9
  //  ........10
  //  ........11
  //  ........12
  //  ........13
  //  ........14
  //  ........15
  
  253/2, 934/4,     // ship starting X, Y location
  8,                // station count
  0x56,             // HS VS HS VS   HS VS VS HS
  3*32+11,  5*16+2, // station 1 X, Y location
  4*32+10,  5*16+3, // station 2 X, Y location
  5*32+10,  5*16+3, // station 3 X, Y location
  3*32+11,  6*16+2, // station 4 X, Y location
  3*32+10,  7*16+3, // station 5 X, Y location
  4*32+11,  7*16+2, // station 6 X, Y location
  3*32+10,  8*16+3, // station 7 X, Y location
  3*32+11,  9*16+2  // station 8 X, Y location
};

const unsigned char mike[] =
{
  253/2, 504/4, // ship starting X, Y location
  8,            // station count
  0xdb,         // VS VS HS VS   VS HS VS VS
   64/2, 452/4, // station 1 X, Y location
   64/2, 708/4, // station 2 X, Y location
  130/2, 192/4, // station 3 X, Y location
  256/2, 388/4, // station 4 X, Y location
  256/2, 580/4, // station 5 X, Y location
  386/2, 192/4, // station 6 X, Y location
  448/2, 452/4, // station 7 X, Y location
  448/2, 708/4  // station 8 X, Y location
};

const unsigned char nathan[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0x18,         // HS HS HS VS   VS HS HS HS
   98/2, 317/4, // station 1 X, Y location
   98/2, 445/4, // station 2 X, Y location
   98/2, 573/4, // station 3 X, Y location
  224/2, 388/4, // station 4 X, Y location
  320/2, 516/4, // station 5 X, Y location
  460/2, 317/4, // station 6 X, Y location
  460/2, 445/4, // station 7 X, Y location
  460/2, 573/4  // station 8 X, Y location
};

const unsigned char thomas[] =
{
  253/2, 934/4, // ship starting X, Y location
  8,            // station count
  0xf0,         // VS VS VS VS   HS HS HS HS
   66/2, 128/4, // station 1 X, Y location
  194/2, 128/4, // station 2 X, Y location
  322/2, 128/4, // station 3 X, Y location
  450/2, 128/4, // station 4 X, Y location
  256/2, 260/4, // station 5 X, Y location
  256/2, 452/4, // station 6 X, Y location
  256/2, 644/4, // station 7 X, Y location
  256/2, 836/4  // station 8 X, Y location
};


const unsigned char * const gamma_levels[] =
{
  albert,
  nathan,
  chris,
  don,
  thomas,
  mike,
  fred,
  darrell
};
